#!BPY

""" Registration info for Blender menus: <- these words are ignored
Name: 'NLA Strip to Anim'
Blender: 243
Group: 'Animation'
Tip: 'NLA Strip Range -> AnimRender Range'
"""

__author__ = "Keines"
__url__ = ("blender", "elysiun", "My HomePage, http://keines.gozaru.jp/blender/index.html")
__version__ = "2007.08.25(Sat) 16:10"

__bpydoc__ = """\

Note:
  Select Strip -> AnimRender Range
"""
import Blender
from Blender import Scene,Object
from Blender.Armature import NLA

# Select Strip Range
def NLAStripRange(ob):
  Start=None
  End=None
  if ob.getType()=="Armature":
    NLAStrips = ob.actionStrips
    # + Loop: NLA
    pose = ob.getPose()
    for strip in NLAStrips:
      if (NLA.Flags['SELECT']&strip.flag):
        # in Select NLA Strip
        if (strip.stripStart<Start)|(Start==None) : Start = strip.stripStart
        if (strip.stripEnd>End)|(End==None)	  :   End = strip.stripEnd
  return int(Start),int(End)

scn = Blender.Scene.GetCurrent()
ob = scn.objects.active
if ob!=None:
  start,end=NLAStripRange(ob)
  if start!=None:
    rc = scn.getRenderingContext()
    rc.startFrame(start)
    rc.endFrame(end)
